//+------------------------------------------------------------------+
//|                                                  NY 7-9 Info.mq4 |
//|                                      Copyright  2012, MandySoft |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2012, MandySoft"
#property link      "http://www.2p.cz/en/forex_metatrader"
// Version: 0.1

#include <NY 7-9.mqh>
#include <AuxLib.mqh>

#property indicator_separate_window

// values in standard pips

#define INDICATOR_NAME "NY 7-9 Info"
extern int Cushion          = 3;
extern int TP1             = 15;
extern int TP2             = 30;
extern int TP3             = 45;
//extern int SL              = -30;   // TODO: MM


double levels[6] = {0};   // sl, margin, tp1, tp2, tp3, end */
double curH, curL;
datetime curDT[4];

double point;
int digits;

int init() {
   point = PipPoint();
   digits = PipDigits();
   
   levels[1] = Cushion * point;
   levels[2] = (Cushion+TP1) * point;
   levels[3] = (Cushion+TP2) * point;
   levels[4] = (Cushion+TP3) * point;
   levels[5] = levels[4] + 25 * point;
   IndicatorShortName(INDICATOR_NAME);
   return(0);
}

void drawInBoxGraphic(bool show) {
// none, done in indicator
   int handle = 0; //WindowFind(NY_7_9_INDICATOR);
   string prefix = "NY79Box";
   if (show) {
      if (ObjectFind(prefix) < 0) {
         ObjectCreate(prefix, OBJ_RECTANGLE, handle, 0, 0, 0, 0);
      }
      ObjectSet(prefix, OBJPROP_TIME1 , curDT[0]);
      ObjectSet(prefix, OBJPROP_TIME2 , curDT[1]);
      
      ObjectSet(prefix, OBJPROP_PRICE1, curH);  
      ObjectSet(prefix, OBJPROP_PRICE2, curL);
      ObjectSet(prefix, OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet(prefix, OBJPROP_COLOR, Ivory);
   } else {
      ObjectDelete(prefix);   
   }
}

void drawBox(string prefix, bool show, double y, double dir, color col) {
   int handle = 0; //WindowFind(NY_7_9_INDICATOR);
   static string strLevel[] = {"STOPLOSS", "TP1", "TP2", "TP3"};
   int i;
   if (show) {
      if (ObjectFind(prefix) < 0) {
         ObjectCreate(prefix, OBJ_RECTANGLE, handle, 0, 0, 0, 0);
         for (i=0; i<=3; i++) {
         
            ObjectCreate(prefix+i, OBJ_TREND, handle, 0, 0, 0);
            ObjectSet(prefix+i, OBJPROP_COLOR, Beige);
            ObjectSet(prefix+i, OBJPROP_STYLE, STYLE_DOT);            
            ObjectSet(prefix+i, OBJPROP_RAY, false);
            ObjectSetText(prefix+i, strLevel[i], 0);
         }
      }
      
      ObjectSet(prefix, OBJPROP_TIME1 , curDT[2]);
      ObjectSet(prefix, OBJPROP_TIME2 , curDT[3]);
      ObjectSet(prefix, OBJPROP_PRICE1, y + dir*levels[1]);  
      ObjectSet(prefix, OBJPROP_PRICE2, y + dir*levels[5]);
      ObjectSet(prefix, OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet(prefix, OBJPROP_COLOR, col);
      //ObjectSet(prefix, OBJPROP_BACK, background);

      for (i = 0; i <= 3; i++) {
        ObjectSet(prefix+i, OBJPROP_TIME1 , curDT[2]);
        ObjectSet(prefix+i, OBJPROP_TIME2 , curDT[3]);
        if (i==0) {
            ObjectSet(prefix+i, OBJPROP_PRICE1, y + dir*levels[0]);
        }
        else {
            ObjectSet(prefix+i, OBJPROP_PRICE1, y + dir*levels[i+1]);
        }
        ObjectSet(prefix+i, OBJPROP_PRICE2, ObjectGet(prefix+i, OBJPROP_PRICE1));
      }      
   } else {
      ObjectDelete(prefix);
      for (i = 0; i <= 4; i++) {
        ObjectDelete(prefix+i);
      }
   }   
}

void drawOutBoxGraphic(bool show) {
   drawBox("NY79High", show, curH, 1, SteelBlue);
   drawBox("NY79Low", show, curL, -1, Salmon);
}
   
string getZoneStr(double y, double dir) {
  string s;
  int i;
  // hidden gem: string is truncated if length exceeds max.len !!!
  s = DoubleToStr(y+dir*levels[1], digits);
  for (i=1; i<=3; i++) {
    s = s + " TP"+i+": "+ DoubleToStr(y+dir*levels[1+i], digits);
  }
  s = s + " SL: "+DoubleToStr(y+dir*(levels[0]-Point*MarketInfo(Symbol(), MODE_SPREAD)), digits);   
  return (s);
}

void drawText(int inBox) {
   string arr[3];
   string id = "Txt";
   int i;
   int handle = WindowFind(INDICATOR_NAME);
   if (inBox < 0) {
      for (i=0; i < ArraySize(arr); i++) {  
         ObjectDelete(id+i);
      }
      return;
   }
   if (ObjectFind(id) < 0) {
     for (i=0; i < ArraySize(arr); i++) {
      ObjectCreate(id+i, OBJ_LABEL, handle, 0, 0);
//     ObjectSet(id, OBJPROP_CORNER, 0);
       ObjectSet(id+i, OBJPROP_XDISTANCE, 10);
       ObjectSet(id+i, OBJPROP_YDISTANCE, 25+i*15);
     }
   }
   
   string s;
   switch (inBox) {
   case 0: s = "FORMING"; break;
   case 1: s = "MARKET"; break;
   }
   arr[0] = "Range: "+DoubleToStr((curH-curL)/point, 0)+" pips   ["+DoubleToStr(curL, digits)+"-"+DoubleToStr(curH, digits)+"] "+s;
   arr[1] = "LONG:  "+getZoneStr(curH + Point*MarketInfo(Symbol(), MODE_SPREAD), 1); // include spread to stoploss to correspond other side of band ??
   arr[2] = "SHORT: "+getZoneStr(curL, -1);
   for (i=0; i < ArraySize(arr); i++) {
     ObjectSetText(id+i, arr[i], 9,"Courier", White);
   } 
}

void deinit() {
  drawInBoxGraphic(false);
  drawOutBoxGraphic(false);
  drawText(-1);
  Comment("");
}

// draw info about latest box of "NY 7-9" indicator
int start()
{
   int i;  
   double l, h;
   int inBox = -1;
   if (Period()>PERIOD_H1) {
      return(0);    // max.reasonable resolution is probably 1 hour
   }
   int countedBars = IndicatorCounted();   
   if (countedBars < 0) return(-1);
   int limit = Bars - countedBars;
   datetime dt;
   int startOfs = 0;  // just for testing has sense non zero value
   /* we could also consider WindowFirstVisibleBar() but how to distinquish when graph is running
    or WindowTimeOnDropped but it does not works for indicator
   */
   /* find end of box */
   for (i=startOfs; i < limit; i++) {
      l = iCustom(NULL, 0, NY_7_9_INDICATOR, NY_7_9_BOX_LOW, i);
      if (l != EMPTY_VALUE) {
         /* in 7-9 interval */
         h = iCustom(NULL, 0, NY_7_9_INDICATOR, NY_7_9_BOX_HIGH, i);
         inBox = 0;
         break;
      } else {
         l = iCustom(NULL, 0, NY_7_9_INDICATOR, NY_7_9_MARKET_LOW, i);
         if (l != EMPTY_VALUE) {
            if (i == startOfs) {
               if (curDT[3] == Time[i]) {
                /* no change, leave it as it */
                  return(0);
               }
            }
            h = iCustom(NULL, 0, NY_7_9_INDICATOR, NY_7_9_MARKET_HIGH, i);
            inBox = 1;            
            break;
         }      
      }      
   }
   if (inBox < 0) {
      /* no box found, leave latest info */
      return (0);
   }
   double newDT2;
   
   int forceRefresh = -1;
   if (inBox == 1) {
      curDT[3] = Time[i];   
      i++;
      /* we are in out box */
      while (i <= Bars) {         
         if (iCustom(NULL, 0, NY_7_9_INDICATOR, NY_7_9_MARKET_LOW, i) == EMPTY_VALUE) {
            if (Time[i-1] != curDT[2]) {
               curDT[2] = Time[i-1];
               forceRefresh = 0;
            } else {
               forceRefresh = 1;
            }
            break;
         }
         i++;
      }      
      if (i >= Bars) {      
         return (0);
      }
   } else {
      curDT[2] = EMPTY_VALUE;
      curDT[3] = EMPTY_VALUE;
      forceRefresh = 0;
   }
   if (forceRefresh == 0) {
      curDT[1] = Time[i];   
      while (i <= Bars) {         
         if (iCustom(NULL, 0, NY_7_9_INDICATOR, NY_7_9_BOX_LOW, i) == EMPTY_VALUE) {
            if (Time[i-1] == curDT[0]) {
               forceRefresh = -1;
            } else {
               curDT[0] = Time[i-1];
            }
            break;
         }
         i++;
      }      
   }   
//Alert(i, " ", TimeToStr(Time[i]), " ", inBox, " ", TimeToStr(curDT[0]), " ", TimeToStr(curDT[1]), " ", TimeToStr(curDT[2]), " ", TimeToStr(curDT[3]));

   if (inBox == 0 && forceRefresh == -1 && (curH != h || curL != l)) {
      forceRefresh = 0;
   }
   
   if (forceRefresh == 0) {
      /* recalc TP, SP etc. */      
      curL = l;
      curH = h;
      levels[0] = l-h;  // SL
   }
   
   if (inBox == 0) {
      /* remove out box graphic if any */
      drawOutBoxGraphic(false);
   }  
   else if (inBox == 1) {
      /* redraw out box graphic (prolong) */   
      drawOutBoxGraphic(true);
   }
   /* redraw in box graphic */
   drawInBoxGraphic(true);
   
   if (forceRefresh == 1) {
   /* no text change in out box possible */
      return(0);   
   }
   if (inBox == 0 && forceRefresh == -1) {
   /* no change in hi-lo in in box */
      return (0);
   }
   drawText(inBox);
   return (0);
}

